# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, playerlib, cmdlib
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func    = es.import_addon('sam/functions')
admins  = es.import_addon('sam/core/admins')
monitor = es.import_addon('sam/core/monitor')
mute    = es.import_addon('sam/core/pcontrol/mute')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
temp    = {'active':True,'showgroup':True}
teams   = {1:'#spec',2:'#t',3:'#ct'}
alltalk = es.ServerVar('sv_alltalk')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# CMDS
	func.ServerCMD('sam_adminschat_active', activeCMD)
	func.ServerCMD('sam_adminschat_showgroup', groupCMD)

	# CFG
	lib = {'sam_adminschat_active':{'value':1,'description':'Active Chat: If 0 Admins need to start talking with # to talk as an Admin, if 1 they dont.'},
		   'sam_adminschat_showgroup':{'value':1,'description':'Show Groups: Shows the Group of the Admin, if he is in one, else he will talk as an Admin.'}}
	monitor.cfg('adminschat', lib)

	# FILTERS
	es.addons.registerSayFilter(chatFilter)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# CMDS
	func.unServerCMD('sam_adminschat_active')
	func.unServerCMD('sam_adminschat_showgroup')

	# FILTERS
	es.addons.unregisterSayFilter(chatFilter)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def chatFilter(ID, TEXT, TEAM):
	text  = TEXT.strip('"')
	R     = (ID, TEXT, TEAM)
	admin = playerlib.getPlayer(ID)
	if admins.can(ID,'Admins Chat'):
		if not ID in func.cloud['filters']:
			cmd = text.split()
			if not es.exists('saycommand', cmd[0]):
				if text.startswith('###'):
					func.centermsg('#all', 'ADMIN : %s' % text.strip('###').strip(' '))
					R = (0,0,0)
				elif text.startswith('##'):
					func.say('#all', '#grey[GLOBAL] : #white%s' % text.strip('##').strip(' '))
					R = (0,0,0)
				elif text.startswith('#') or temp['active']:
					if not TEAM:
						if not text.startswith('#'):
							if not admins.getkey(admin.steamid,'group') == 'NO_GROUP': group = admins.getkey(admin.steamid,'group')
							else: group = False
							if group and temp['showgroup']:
								color = admins.groups.getkey(group,'color')
								if admin.isdead:
									if admin.teamid != 1: func.say('#all', '*DEAD* #grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[admin.teamid],admin.name,str(text)))
									else: func.say('#all', '*SPEC* #grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[admin.teamid],admin.name,str(text)))
								else: func.say('#all', '#grey[%s%s#grey] %s%s #default: %s' % (color,group.upper(),teams[admin.teamid],admin.name,str(text)))
							elif admin.isdead:
								if int(alltalk) == 1:
									if admin.teamid != 1: func.say('#all', '*DEAD* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text))
									else: func.say('#all', '*SPEC* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text))
								else:
									if admin.teamid != 1: func.say('#dead', '*DEAD* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text))
									else: func.say('#dead', '*SPEC* #grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text))
							else: func.say('#all', '#grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text))
						else: func.say('#all', '#grey[#cyanADMIN#grey] %s%s #default: %s' % (teams[admin.teamid],admin.name,text.strip('#').strip(' ')))
						R = (0, 0, 0)
					else:
						if text.startswith('#'):
							for ply in playerlib.getPlayerList('#all'):
								if admins.isAdmin(ply.steamid): func.say(ply, '#green[ADMINS ONLY] #grey%s#green: #lightgreen%s' % (admin.name,text.strip('#').strip(' ')))
							R = (0, 0, 0)
	elif text.startswith('#'):
		for ply in playerlib.getPlayerList('#all'):
			if admins.isAdmin(ply.steamid) or ply == admin: func.say(ply, '#green%s to Admins #green: #lightgreen%s' % (admin.name,text.strip('#').strip(' ')))
		func.say(ID, '#greenYou to Admins #green: #lightgreen%s' % (text.strip('#').strip(' ')))
		R = (0, 0, 0)
	return R

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def activeCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['active'] = bool(args)
		except: pass

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def groupCMD(args):
	if args:
		try:
			args = int(' '.join(args))
			if args in (1,0): temp['showgroup'] = bool(args)
		except: pass

# =============================================================================== #